<?php

class North_Extension extends DiviExtension {

	/**
	 * The gettext domain for the extension's translations.
	 *
	 * @since 1.0
	 *
	 * @var string
	 */
	public $gettext_domain = 'north-checkout';

	/**
	 * The extension's WP Plugin name.
	 *
	 * @since 1.0
	 *
	 * @var string
	 */
	public $name = 'north-checkout-form';

	/**
	 * The extension's version
	 *
	 * @since 1.0
	 *
	 * @var string
	 */
	public $version = '2.0';

	/**
	 * North_Extension constructor.
	 *
	 * @param string $name
	 * @param array  $args
	 */
	public function __construct( $name = 'north-checkout', $args = array() ) {
		$this->plugin_dir     = plugin_dir_path( __FILE__ );
		$this->plugin_dir_url = plugin_dir_url( $this->plugin_dir );

		parent::__construct( $name, $args );
	}
}

new North_Extension;
