// External Dependencies
import React, {Component, Fragment} from 'react';
import axios from 'axios';

// Internal Dependencies
import './style.css';


class NorthCheckout extends Component {

    // constructor() {
    //     super();
    // }

    static slug = 'north_checkout';

  renderTag = (tag, title) => {
      switch(tag) {
          case "h1":
              return <h1 className="north_checkout_title">{title}</h1>
          case "h2":
              return <h2 className="north_checkout_title">{title}</h2>
          case "h3":
              return <h3 className="north_checkout_title">{title}</h3>
          case "h4":
              return <h4 className="north_checkout_title">{title}</h4>
          case "h5":
              return <h5 className="north_checkout_title">{title}</h5>
          case "h6":
              return <h6 className="north_checkout_title">{title}</h6>
      }
  };

    render() {
    const { content = [] } = this.props;

    return (
        <div className={"checkout"} >
            {
                this.renderTag(this.props.title_level, this.props.title)
            }
            <form id="payment-form" className={"north_checkout clearfix"} method="post" data-redirect={this.props.redirect_url}>

                {content}

                <div className="et_checkout_bottom_container">
                    <button type="submit" name="et_builder_submit_button" className="checkout_submit et_pb_button">{this.props.submit_button_text}</button>
                </div>
            </form>
        </div>
    );
  }
}

export default NorthCheckout;
