// External Dependencies
import React, {Component} from 'react';
import axios from 'axios';

class NorthCheckoutItem extends Component {

    constructor() {
        super();
        this.state = {
            product_html: '',
            name: '',
            price: null,
        }
    }


    static slug = 'checkout_field';

    async componentDidMount() {
        const {half_width_field, product_item, moduleInfo: {type, address} = {}} = {} = this.props;

        if(half_width_field === 'on') {
            var elems = document.querySelector('.checkout_field[data-address="' + address + '"]');
            elems.style.width = 'calc(50% - 12px)';
        }


        // if(product_item && this.state.product_html === '') {
        //     let form_data = new FormData;
        //
        //     form_data.append('action', 'get_render_data');
        //     form_data.append('id', product_item);
        //
        //     const result = await axios.post('/divi/wp-admin/admin-ajax.php', form_data).then( response => {
        //         return response.data;
        //     }).catch( function (error) {
        //         console.log(222, error);
        //     });
        //
        //     this.setState({product_html: result});
        // }

    }

    async componentDidUpdate(prevProps, prevState, snapshot) {
        // const { props: { props: { shortcode_index: oldValue } = {}} = {}} = prevProps;
        // const { props: { props: { shortcode_index: newValue } = {}} = {}} = this.props;

        const {half_width_field, moduleInfo: {type, order} = {}} = {} = this.props;

        if(half_width_field === 'on') {
            var elems = document.getElementsByClassName(type + " " + type + "_" + order)[0];
            elems.style.width = 'calc(50% - 12px)';
        }

        // //if (oldValue !== newValue) {
        //     let form_data = new FormData;
        //
        //
        //     console.log("Lalala + update");
        //
        //     form_data.append('action', 'get_render_data');
        //     form_data.append('id', 888);
        //
        //     const result = await axios.post('/divi/wp-admin/admin-ajax.php', form_data).then( response => {
        //         console.dir(response);
        //
        //         return response.data;
        //     }).catch( function (error) {
        //         console.log(222, error);
        //     });
        // //}
    }


    render() {
        const {field_id, field_type, dynamic_input_text, show_qty, show_inventory, apply_text, field_inventory_label, dynamic_input_text_before, dynamic_input_text_after, field_title, show_label, field_label, product_item, bump_title, order_bump, price_text_before, price_text_after, order_before, order_after, address_line_2, country, city, state, zip, address_line_2_title, country_title, city_title, state_title, zip_title, address_line_2_label, country_label, city_label, state_label, zip_label} = {} = this.props;
        let options = '';
        let label = '';
        let qty = '';
        let inventory = '';
        let apply = '';

        if(show_label === 'on') {
            label = <label htmlFor={field_id} className="field_label">{field_label}</label>;
        }

        console.log(apply_text);

        if(apply_text === undefined) {
            apply = 'Apply';
        }else {
            apply = apply_text;
        }

        if(show_qty === 'on') {
            qty = <div className="quantity-wrapper"><label className="quantity-label" htmlFor="quantity_6">Quantity: </label><div className="qty-input"><span className="qty-minus"></span><input type="number" id="quantity" name="quantity" min="1" value="1"/><span className="qty-plus"></span></div></div>;
        }

        if(show_inventory === 'on') {
            var inventory_label = field_inventory_label ? field_inventory_label : 'Inventory:';
            inventory = <div className="inventory">{inventory_label} N/A</div>;
        }

            switch(field_type) {
                case 'payment_buttons':
                    return (
                        <div>
                            {label}
                            <div className="payment-buttons">
                                <div className="apple-pay-button">
                                    <span className="logo"></span>
                                    <span className="text">Pay</span>
                                </div>
                                <div className="google-pay-button">
                                    <span className="logo"></span>
                                    <span className="text">Pay</span>
                                </div>
                            </div>
                        </div>
                    );
                    break;
                case 'paypal_buttons':
                    return (
                        <div>
                            {label}
                            <div id="paypal-buttons">
                                <div className="paypal-button paypal-button-number-0 paypal-button-layout-vertical paypal-button-shape-rect paypal-button-number-multiple paypal-button-env-sandbox paypal-button-color-gold paypal-button-text-color-black paypal-logo-color-blue paypal-button-has-menu-false" tabIndex="0" aria-label="PayPal">
                                    <div className="paypal-button-label-container">
                                    </div>
                                </div>
                                <div className="paypal-button paypal-button-number-1 paypal-button-layout-vertical paypal-button-shape-rect paypal-button-number-multiple paypal-button-env-sandbox paypal-button-color-black paypal-button-text-color-white paypal-logo-color-white paypal-button-has-menu-false" tabIndex="0" aria-label="Debit or credit card">
                                    <div className="paypal-button-label-container">
                                        <span className="img"></span>
                                        <span className="paypal-button-text true">Debit or credit card</span>
                                    </div>
                                </div>
                                <div className="paypal-powered-by">
                                    <span className="paypal-button-text immediate">Powered </span><span className="img"></span>
                                </div>
                            </div>
                        </div>
                    );
                    break;
                case 'product':
                    return (
                        <div>
                            {label}
                            <div className={"checkout_product checkout_field"}>
                                <div className="checkout_product_head">
                                    <h4 id="product_name_origin">Product name</h4>
                                    <div className="product_data">
                                        <div className="price_before">{price_text_before}</div>
                                        <p id="product_single_price" className="price">Price: $<span className="value">0.00</span></p>
                                        <div className="price_after">{price_text_after}</div>
                                        {inventory}
                                    </div>
                                </div>
                                {qty}
                                <input type="hidden" name="checkout_product" id="checkout_product" value={product_item} />
                            </div>
                        </div>
                    );
                    break;
                case 'dynamic_product':
                    return (
                        <div>
                            {label}
                            <div className={"checkout_product checkout_field_dynamic_product checkout_field"}>
                                <div className="checkout_product_head">
                                    <div className="product_title_block">
                                        <h4 id="product_name_origin">{dynamic_input_text}</h4>
                                    </div>
                                    <div className="product_data">
                                        <div className="price_before">{dynamic_input_text_before}</div>
                                        <div className="price-block">
                                            <input type="number" name="dynamic_price_14" id="product_single_price" className="price" min="0" step="0.01" value="0" />
                                        </div>
                                        <div className="price_after">{dynamic_input_text_after}</div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    );
                    break;
                case 'bump':
                    return (
                        <div>
                            {label}
                            <div className={"checkout_order_bump"}>
                                <span className="checkout_field_checkbox">
                                    <input type="checkbox" id={"checkout_" + field_id} className="input" name="checkout_bump" value={order_bump} data-price="price" />
                                    <label for={"checkout_" + field_id}><i></i>{bump_title ? bump_title : 'Use this option to buy bump'}</label>
                                </span>
                            </div>
                        </div>
                    );
                    break;
                case 'coupon':
                    return (
                        <div>
                            {label}
                            <div className="coupon-wrap">
                                <input type="text" id="checkout_coupon_coupon" className="input text-input checkout-coupon " value="" name="checkout_coupon_coupon" data-field_type="coupon" data-original_id="coupon" placeholder={field_title} />
                                <button className="apply-coupon">
                                    <span>{apply}</span>
                                </button>
                            </div>
                        </div>
                    );
                    break;
                case 'total':
                    return (
                        <div>
                            {label}
                            <div className={"checkout_total"}>
                                <input type="hidden" id="checkout_price" name="checkout_price" value="price"/>
                                <h4>{field_title}</h4>
                                <p className="price" data-origin="price"><span className="before">{order_before}</span> $Total <span className="after">{order_after}</span></p>
                            </div>
                        </div>
                    );
                    break;
                case 'card':
                    return (
                        <div>
                            {label}
                            <label htmlFor={field_id} className="north_checkout_label">{field_id}</label>
                            <div id="card-element">Card Info fields can't be rendered in the visual builder</div>
                        </div>
                    );
                    break;
                case 'address':
                    let _line_2_label = '';
                    let _city_label = '';
                    let _state_label = '';
                    let _zip_label = '';
                    let _country_label = '';

                    if(show_label === 'on') {
                        _line_2_label = <label htmlFor={"checkout_line_2_" + field_id} className="field_label">{address_line_2_label}</label>;
                        _city_label = <label htmlFor={"checkout_city_" + field_id} className="field_label">{city_label}</label>;
                        _state_label = <label htmlFor={"checkout_state_" + field_id} className="field_label">{state_label}</label>;
                        _zip_label = <label htmlFor={"checkout_zip_" + field_id} className="field_label">{zip_label}</label>;
                        _country_label = <label htmlFor={"checkout_country_" + field_id} className="field_label">{country_label}</label>;
                    }

                    return(
                        <div className={field_type + " " + field_type + "_" + this.props.moduleInfo.order + " " + field_type + "_" + field_type} data-id={field_id} data-type={field_type}>
                            {label}
                            <input type="text" id={"checkout_address_" + field_id} className="input input_autocomplete" name="checkout_address" onFocus="initAutocomplete(this)" placeholder={field_title} />
                            <div class="additional_address">
                                {(!address_line_2 || address_line_2 === 'on') && (
                                    <div className={"input_apartment"}>
                                        {_line_2_label}
                                        <input type="text" id={"checkout_line_2_" + field_id} className="input" name="checkout_line_2" placeholder={address_line_2_title ? address_line_2_title : 'Address line 2'} />
                                    </div>
                                )}
                                {(!city || city === 'on') && (
                                    <div className={"input_city"}>
                                        {_city_label}
                                        <input type="text" id={"checkout_city_" + field_id} className="input" name="checkout_city" placeholder={city_title ? city_title : 'City'} />
                                    </div>
                                )}
                                {(!state || state === 'on') && (
                                    <div className={"input_state"}>
                                        {_state_label}
                                        <input type="text" id={"checkout_state_" + field_id} className="input" name="checkout_state" placeholder={state_title ? state_title : 'State'} />
                                    </div>
                                )}
                                {(!zip || zip === 'on') && (
                                    <div className={"input_zip"}>
                                        {_zip_label}
                                        <input type="text" id={"checkout_zip_" + field_id} className="input" name="checkout_zip" placeholder={zip_title ? zip_title : 'Zip'} />
                                    </div>
                                )}
                                {(!country || country === 'on') && (
                                    <div className={"input_country"}>
                                        {_country_label}
                                        <input type="text" id={"checkout_country_" + field_id} className="input" name="checkout_country" placeholder={country_title ? country_title : 'Country'} />
                                    </div>
                                )}
                            </div>
                        </div>
                    );
                    break;
                case 'select':

                    options = JSON.parse(this.props.select_options);

                    return(
                        <div className={"checkout_field_select"}>
                            {label}
                            <select className="checkout_select input" name={"checkout_select_" + field_id}>
                                <option value={field_title}>{field_title}</option>
                                {
                                    options.map(item => {
                                        return (
                                            <option value={item.value}>{item.value}</option>
                                        )
                                    })
                                }
                            </select>
                        </div>
                    );
                    break;
                case 'checkbox':

                    options = JSON.parse(this.props.checkbox_options);

                    return(
                        <div className={"checkout_field_options_wrapper"}>
                            <span className="checkout_field_options_title">{field_title}</span>
                            <span className="checkout_field_options_list">
                                {
                                    options.map((item, index) => {
                                        return (
                                            <span className="checkout_field_checkbox">
                                                <input type="checkbox" id={"checkout_" + field_id + "_" + index} className="input" name={"checkout_checkbox_" + field_id + "[]"} value={item.value} data-id={item.dragID} />
                                                <label htmlFor={"checkout_" + field_id + "_" + index}><i></i>{item.value}</label>
                                            </span>
                                        )
                                    })
                                }
                            </span>
                        </div>
                    );
                    break;
                case 'radio':

                    options = JSON.parse(this.props.radio_options);

                    return(
                        <span className="checkout_field_options_wrapper">
                            <span className="checkout_field_options_title">{field_title}</span>
                            <span className="checkout_field_options_list">
                                {
                                    options.map((item, index) => {
                                        return (
                                            <span className="checkout_field_radio">
                                                <input type="radio" id={"checkout_" + field_id + "_" + index} className="input" name={"checkout_radio_" + field_id + "[]"} value={item.value} />
                                                <label htmlFor={"checkout_" + field_id + "_" + index}><i></i>{item.value}</label>
                                            </span>
                                        )
                                    })
                                }
                            </span>
                        </span>
                    );
                    break;
                case 'email':
                    return(
                        <div>
                            {label}
                            <input type="email" id={field_id} className="input"  name={"checkout_input_" + field_id} data-required_mark="required" data-field_type="input" placeholder={field_title} />
                        </div>
                    );
                    break;
                case 'phone':
                    return(
                        <div>
                            {label}
                            <input type="tel" id={field_id} className="input"  name={"checkout_input_" + field_id} data-required_mark="required" data-field_type="input" placeholder={field_title} />
                        </div>
                    );
                    break;
                default:
                    return(
                        <div>
                            {label}
                            <input type="text" id={field_id} className="input"  name={"checkout_input_" + field_id} data-required_mark="required" data-field_type="input" placeholder={field_title} />
                        </div>
                    );
            }
    }
}

export default NorthCheckoutItem;