// External Dependencies
import React, {Component, Fragment} from 'react';

class NorthUpsell extends Component {

    static slug = 'north_upsell';

  renderTag = (tag, title) => {
      switch(tag) {
          case "h1":
              return <h1 className="north_checkout_title">{title}</h1>
          case "h2":
              return <h2 className="north_checkout_title">{title}</h2>
          case "h3":
              return <h3 className="north_checkout_title">{title}</h3>
          case "h4":
              return <h4 className="north_checkout_title">{title}</h4>
          case "h5":
              return <h5 className="north_checkout_title">{title}</h5>
          case "h6":
              return <h6 className="north_checkout_title">{title}</h6>
      }
  };

    render() {
    const { content = [] } = this.props;

    let button_alignment = '';

    if(typeof(this.props.button_alignment) != "undefined" && this.props.button_alignment !== null) {
        button_alignment += ' et_pb_button_alignment_' + this.props.button_alignment + ' ';
    }

    if(typeof(this.props.button_alignment_phone) != "undefined" && this.props.button_alignment_phone !== null) {
        button_alignment += ' et_pb_button_alignment_phone_' + this.props.button_alignment_phone + ' ';
    }

    if(typeof(this.props.button_alignment_tablet) != "undefined" && this.props.button_alignment_tablet !== null) {
        button_alignment += ' et_pb_button_alignment_tablet_' + this.props.button_alignment_tablet + ' ';
    }

    return (
        <div className={"et_pb_button_module_wrapper et_pb_module " + button_alignment}>
            <a className="north_upsell et_pb_button et_pb_bg_layout">{this.props.button_text}<div class="loader"></div></a>
        </div>
    );
  }
}

export default NorthUpsell;
