<?php

namespace NorthStripe\Service\BillingPortal;

class SessionService extends \NorthStripe\Service\AbstractService
{
    /**
     * Creates a session of the self-serve portal.
     *
     * @param null|array $params
     * @param null|array|\NorthStripe\Util\RequestOptions $opts
     *
     * @throws \NorthStripe\Exception\ApiErrorException if the request fails
     *
     * @return \NorthStripe\BillingPortal\Session
     */
    public function create($params = null, $opts = null)
    {
        return $this->request('post', '/v1/billing_portal/sessions', $params, $opts);
    }
}
